<?
include ("common.php");

#########################
#  Main Program
##########################
global $db;

open_db();
create_db_table ();

if ($REQUEST_METHOD == "POST") {
  doPost();
} else {
  doGet();
}

function doPost() {
  global $delete, $uid;
  if (isset($delete)) {
    doDelete();
  } else if (isset($uid)) {
    doUpdate();
  } else {
    doInsert();
  }
}

function doInsert() {
  global $oper, $lac, $cid, $name, $address, $city, $state, $zip, $latitude, $longitude, $isTowerLocation, $isIndoors, $signalStrength, $asu, $dbm;
  processDefaults();
  error_log( "insert $oper $lac $cid $name $address $city $state $zip $latitude $longitude $isTowerLocation $isIndoors $signalStrength $asu $dbm");
  $result = do_db_insert ($oper,$lac,$cid,$name,$address,$city,$state,$zip,$latitude,$longitude,$isTowerLocation,$isIndoors,$signalStrength,$asu,$dbm);
  if ($result == "") {
    loseError();
  } else {
    Header("Content-type: application/x-www-form-urlencoded");
    $_POST['uid']=$result;
    outputPOST();
  }
}

function doUpdate() {
  global $uid, $oper, $lac, $cid, $name, $address, $city, $state, $zip, $latitude, $longitude, $isTowerLocation, $isIndoors, $signalStrength, $asu, $dbm;
  processDefaults();
  error_log( "update $uid,$oper,$lac,$cid,$name,$address,$city,$state,$zip,$latitude,$longitude,$isTowerLocation,$isIndoors,$signalStrength,$asu,$dbm");
  $result = do_db_update ($uid,$oper,$lac,$cid,$name,$address,$city,$state,$zip,$latitude,$longitude,$isTowerLocation,$isIndoors,$signalStrength,$asu,$dbm);
  if ($result == "") {
    loseError();
  } else {
    Header("Content-type: application/x-www-form-urlencoded");
    outputPOST();
  }
}

function doDelete() {
  global $uid, $recordUID;
  $lost = true;
  error_log("deleting uid=$uid recordUID=$recordUID");
  if ($uid != "") {
    $result = do_db_delete ($uid);
    if ($result != "") $lost = false;
  } else {
    $lost = false;		// let them delete records with no UID
  error_log("doing nothing for delete of empty uid recordUID=$recordUID");
  }
  if ($lost) {
    loseError();
  } else {
    Header("Content-type: application/x-www-form-urlencoded");
    outputPOST();
  }
}

function loseError() {
  Header("HTTP/1.0 500 Internal Server Error");
  print mysql_error();
}

function outputPOST() {
  global $_POST;
  while (list($name, $value) = each($_POST)) {
    echo "&$name=" . urlencode(stripslashes($value));
  }
}

function doGet() {
  // REQUEST_METHOD is GET so offer an editable form
  // Get the values first
  global $uid, $db;
  if ($uid != "") {
    $query = "SELECT * FROM TowerData where uid='".addslashes($uid)."'";
    $results = mysql_query ($query,$db) or die ("Invalid mysql command: ".mysql_error() . "<br>\n");
    if (mysql_num_rows ($results) > 1) {
      die ("Our query $query did not match 1 row exactly. It matched ".mysql_num_rows ($results)." rows");
    };
    
    list ($db_uid,$db_oper,$db_lac,$db_cid,$db_name,$db_address,$db_city,$db_state,$db_zip,$db_latitude,$db_longitude,$db_isTowerLocation,$db_isIndoors,$db_signalStrength,$db_asu,$db_dbm) = mysql_fetch_row ($results);
    $db_uid = stripslashes($db_uid);
    $db_oper = stripslashes($db_oper);
    $db_lac = stripslashes($db_lac);
    $db_cid = stripslashes($db_cid);
    $db_name = stripslashes($db_name);
    $db_address = stripslashes($db_address);
    $db_city = stripslashes($db_city);
    $db_state = stripslashes($db_state);
    $db_zip = stripslashes($db_zip);
    $db_latitude = stripslashes($db_latitude);
    $db_longitude = stripslashes($db_longitude);
    $db_isTowerLocation = stripslashes($db_isTowerLocation);
    $db_isIndoors = stripslashes($db_isIndoors);
    $db_signalStrength = stripslashes($db_signalStrength);
    $db_asu = stripslashes($db_asu);
    $db_dbm = stripslashes($db_dbm);
    echo "<h1>Information for uid ",$uid,"</h1>\n";
  } else {
    $db_uid = ""; // ?????
    $oper = "";
    $lac = "";
    $cid = "";
    $name = "";
    $address = "";
    $city = "";
    $state = "";
    $zip = "";
    $latitude = "";
    $longitude = "";
    $isTowerLocation = false;
    $isIndoors = false;
    $signalStrength = "";
    $asu = 0;
    $dbm = 0;
  };
  // If the user specified values on the command line then these will override the db values

  if (isset ($oper)) { $db_oper = $oper; };
  if (isset ($lac))  { $db_lac  = $lac; };
  if (isset ($cid))  { $db_cid  = $cid; };
  if (isset ($name))  { $db_name  = $name; };
  if (isset ($address))  { $db_address  = $address; };
  if (isset ($city))  { $db_city  = $city; };
  if (isset ($state))  { $db_state  = $state; };
  if (isset ($zip))  { $db_zip  = $zip; };
  if (isset ($latitude)) { $db_latitude = $latitude; };
  if (isset ($longitude))  { $db_longitude  = $longitude; };
  if (isset ($isTowerLocation))  { $db_isTowerLocation  = $isTowerLocation; };
  if (isset ($isIndoors))  { $db_isIndoors  = $isIndoors; };
  if (isset ($signalStrength))  { $db_signalStrength  = $signalStrength; };
  if (isset ($asu))  { $db_asu  = $asu; };
  if (isset ($dbm))  { $db_dbm  = $dbm; };

  if ($db_isTowerLocation == 'true') $checkedIfTower="checked='checked'";
  if ($db_isIndoors == 'true') $checkedIfIndoors="checked='checked'";

  echo <<<END

  <html>
  <head><title>Edit / Add Data</title></head>
  <body>
  <form action="update.php" method="post">
  <table>
  <input type="hidden" name="uid" value="$db_uid">
  <tr><td>Oper:</td> 
      <td><input type="text" name="oper" value="$db_oper"></td>
  </tr>

  <tr><td>Lac:</td>
      <td><input type="text" name="lac"  value="$db_lac"></td>
  </tr>

  <tr><td>cid:</td>
      <td><input type="text" name="cid"  value="$db_cid"></td>
  </tr>

  <tr><td>Name:</td>
      <td><input type="text" name="name"  value="$db_name"></td>
  </tr>

  <tr><td>Address:</td>
      <td><input type="text" name="address"  value="$db_address"></td>
  </tr>

  <tr><td>City:</td>
      <td><input type="text" name="city"  value="$db_city"></td>
  </tr>

  <tr><td>State:</td>
      <td><input type="text" name="state"  value="$db_state"></td>
  </tr>

  <tr><td>Zip:</td>
      <td><input type="text" name="zip"  value="$db_zip"></td>
  </tr>

  <tr><td>Latitude:</td>
      <td><input type="text" name="latitude"  value="$db_latitude"></td>
  </tr>

  <tr><td>Longitude:</td>
      <td><input type="text" name="longitude"  value="$db_longitude"></td>
  </tr>

  <tr><td>Is this Tower Location?:</td>
      <td><input type="checkbox" name="isTowerLocation" $checkedIfTower value="true"></td>
  </tr>

  <tr><td>Is this location indoors?:</td>
      <td><input type="checkbox" name="isIndoors" $checkedIfIndiirs value="true"></td>
  </tr>

   <tr><td>Signal Strength</td>
       <td><input type="text" name="signalStrength"  value="$db_signalStrength"></td>
   </tr>

 <tr><td>ASU</td>
       <td><input type="text" name="asu"  value="$db_asu"></td>
   </tr>

 <tr><td>dbm</td>
       <td><input type="text" name="dbm"  value="$db_dbm"></td>
   </tr>


      </table>
      <input type="submit" value="Make changes">
     </form>
   </body>
   </html>
END;
}

?>
